import React, { useEffect } from 'react';
import classNames from 'classnames';
import { Field } from 'react-final-form';
import { bool, func, object, shape, string } from 'prop-types';

import { ValidationError, ExpandingTextarea } from '..';

import css from './FieldTextInput.module.scss';

const CONTENT_MAX_LENGTH = 5000;

const FieldTextInputComponent = ({
  rootClassName,
  className,
  inputRootClass,
  customErrorText,
  id,
  label,
  input,
  meta,
  onUnmount,
  isUncontrolled,
  inputRef,
  onChange: customOnChange,
  ...rest
}) => {
  if (label && !id) {
    throw new Error('id required when a label is given');
  }

  const { valid, invalid, touched, error } = meta;
  const isTextarea = input.type === 'textarea';

  const errorText = customErrorText || error;

  // Error message and input error styles are only shown if the
  // field has been touched and the validation has failed.
  const hasError = !!customErrorText || !!(touched && invalid && error);

  const fieldMeta = {
    touched: hasError,
    error: errorText,
  };

  // Textarea doesn't need type.
  const { type, onChange, ...inputWithoutType } = input;
  // Uncontrolled input uses defaultValue instead of value.
  const { value: defaultValue, ...inputWithoutValue } = input;
  // Use inputRef if it is passed as prop.
  const refMaybe = inputRef ? {
    ref: inputRef,
  } : {
  };
  const handleChange = e => {
    if (typeof customOnChange === 'function') customOnChange(e);
    onChange(e);
  };

  const inputClasses = inputRootClass
    || classNames(css.input, {
      [css.inputSuccess]: valid,
      [css.inputError]: hasError,
    });
  const maxLength = CONTENT_MAX_LENGTH;

  const inputProps = {
    className: inputClasses,
    id,
    ...refMaybe,
    ...rest,
    ...(isTextarea && {
      rows: 1, maxLength,
    }),
    ...((isTextarea) && {
      ...inputWithoutType,
    }),
    ...((isTextarea || !isUncontrolled) && {
      onChange: handleChange,
    }),
    ...(!isTextarea && {
      type, defaultValue, ...inputWithoutValue,
    }),
    ...((!isTextarea && !isUncontrolled) && {
      type, input,
    }),
  };

  // eslint-disable-next-line no-console
  console.log(inputProps);

  const classes = classNames(rootClassName || css.root, className);

  return (
    <div className={classes}>
      {label ? (
        <label htmlFor={id}>
          {label}
        </label>
      ) : null}
      {isTextarea ? <ExpandingTextarea {...inputProps} /> : <input {...inputProps} />}
      <ValidationError fieldMeta={fieldMeta} />
    </div>
  );
};

FieldTextInputComponent.defaultProps = {
  rootClassName: null,
  className: null,
  inputRootClass: null,
  onUnmount: null,
  customErrorText: null,
  id: null,
  label: null,
  isUncontrolled: false,
  inputRef: null,
  onChange: null,
};

FieldTextInputComponent.propTypes = {
  rootClassName: string,
  className: string,
  inputRootClass: string,

  onUnmount: func,

  // Error message that can be manually passed to input field,
  // overrides default validation message
  customErrorText: string,

  // Label is optional, but if it is given, an id is also required so
  // the label can reference the input in the `for` attribute
  id: string,
  label: string,

  // Uncontrolled input uses defaultValue prop, but doesn't pass value from form to the field.
  // https://reactjs.org/docs/uncontrolled-components.html#default-values
  isUncontrolled: bool,
  // a ref object passed for input element.
  /* TODO: Replace with shape */
  // eslint-disable-next-line react/forbid-prop-types
  inputRef: object,

  // Generated by final-form's Field component
  input: shape({
    onChange: func.isRequired,
    // Either 'textarea' or something that is passed to the input element
    type: string.isRequired,
  }).isRequired,
  /* TODO: Replace with shape */
  // eslint-disable-next-line react/forbid-prop-types
  meta: object.isRequired,
  onChange: func,
};

const FieldTextInput = ({ unMount, ...restProps }) => {
  useEffect(() => {
    if (unMount) {
      unMount();
    }
  }, [ unMount ]);

  return <Field component={FieldTextInputComponent} {...restProps} />;
};

FieldTextInput.defaultProps = {
  unMount: null,
};

FieldTextInput.propTypes = {
  unMount: func,
};

export default FieldTextInput;
